#!", "usr", "bin", "env python
#-*- coding:utf-8 -*-
import sys
import os
import re

dbgMethod = """	@Override
	%s {
		lastCommand += "->%s";
		super.%s(%s);
	}"""

ignorefilter = set([
	"protected void act() throws ActionCommandException {",
	"protected void move(Area destination, int x, int y) throws ActionCommandException {",
	"protected void move(List<EntityID> path, Pair<Integer, Integer> location) throws ActionCommandException {",
	"protected void move(List<EntityID> path) throws ActionCommandException {",
	"protected void move(EntityID destination, CostFunction costFunc) throws ActionCommandException {",
	"protected void move(EntityID destination) throws ActionCommandException {",
	"protected void move(Collection<? extends StandardEntity> destinations, CostFunction costFunc) throws ActionCommandException {",
	"protected void move(Collection<? extends StandardEntity> destinations) throws ActionCommandException {",
	#AT
	"protected void rescue(Human target) throws ActionCommandException {",
	"protected void load(Human target) throws ActionCommandException {",
	#FB
	"protected void extinguish(Building target, int water) throws  ActionCommandException {",
	"protected void extinguish(EntityID target) throws  ActionCommandException {",
	"protected void extinguish(Building target) throws  ActionCommandException {",
	#PF
	"protected void clear(Blockade block) throws ActionCommandException {",
])

def makeDebugs(srcfiles):
	lines = set()
	for srcfile in srcfiles:
		if not os.path.isfile(srcfile): continue
		with open(srcfile) as src:
			for line in src:
				line = line.strip()
				if line in lines: continue
				if line in ignorefilter: continue
				if "abstract" in line: continue
				m = re.match(r"[\b\t]*((?:(?:protected)|(?:public)) .+ (.+)\((.*)\) throws ActionCommandException)", line)
				if not m is None:
					lines.add(line)
					methodLine = m.group(1)
					name = m.group(2)
					args = m.group(3)
					if len(args) > 0:
						args = re.sub(r"<[^>]*>", "", args)
						args = ", ".join([re.match(r".* (.*)", arg).group(1) for arg in args.split(", ")])
					print dbgMethod % (methodLine, name, name, str(args))
				elif re.match(r"[\b\t]*private .+ throws ActionCommandException {", line):
					print >> sys.stderr, "警告: privateになっているものがあります"
					print >> sys.stderr,  line
	return 0

import os.path

def main():
	if sys.argv[1] == "-at":
		makeDebugs([
				os.path.join("src", "rione", "agent", "Agent.java"),
				os.path.join("src", "rione", "agent", "HumanoidAgent.java"),
				os.path.join("src", "rione", "agent", "PlatoonAgent.java"),
				os.path.join("src", "rione", "agent", "at", "AbstractAmbulanceTeamAgent.java"),
				os.path.join("src", "rione", "agent", "at", "AmbulanceTeamAgent.java"),
				])
	elif sys.argv[1] == "-fb":
		makeDebugs([
				os.path.join("src", "rione", "agent", "Agent.java"),
				os.path.join("src", "rione", "agent", "HumanoidAgent.java"),
				os.path.join("src", "rione", "agent", "PlatoonAgent.java"),
				os.path.join("src", "rione", "agent", "fb", "AbstractFireBrigadeAgent.java"),
				os.path.join("src", "rione", "agent", "fb", "FireBrigadeAgent.java"),
				])
	elif sys.argv[1] == "-pf":
		makeDebugs([
				os.path.join("src", "rione", "agent", "Agent.java"),
				os.path.join("src", "rione", "agent", "HumanoidAgent.java"),
				os.path.join("src", "rione", "agent", "PlatoonAgent.java"),
				os.path.join("src", "rione", "agent", "pf", "AbstractPoliceForceAgent.java"),
				os.path.join("src", "rione", "agent", "pf", "PoliceForceAgent.java"),
				])
	else:
		makeDebugs(sys.argv[1:])

if __name__ == '__main__':
	sys.exit(main())

