package rione.agent.pf;

import java.awt.Graphics2D;
import java.util.Collection;

import rescuecore2.messages.Command;
import rescuecore2.misc.gui.ScreenTransform;
import rescuecore2.worldmodel.ChangeSet;
import rione.agent.DebugAgent;
import rione.model.AdvancedWorldModel;
import rione.viewer.component.AdvancedViewComponent;
import rione.viewer.component.extension.ExtensionMap;

/**
 * デバッグ時は実行の構成の起動オプションからこちらを起動する
 * @author utisam
 *
 */
public class DebugPoliceOfficeAgent extends PoliceOfficeAgent implements DebugAgent {

	/** 最後に呼び出されたメソッドを表す文字列 */
	private String lastCommand = null;

	@Override
	protected void initialize() {
		super.initialize();
		//ビューアに登録
		AdvancedViewComponent.addTeamAgent(this);
	}

	@Override
	public AdvancedWorldModel getWorld() {
		return world;
	}

	/*
	 * 自由に設定できるEntityIDと装飾の対応
	 * (非 Javadoc)
	 * @see rione.viewer.component.DebugAgent#customExtension()
	 */
	@Override
	public ExtensionMap customExtension() {
		ExtensionMap exMap = new ExtensionMap();
//		for (Area area : crossses) {
//			exMap.put(area.getID(), new EntityExtension(Color.RED, new BasicStroke(3.0f)));
//		}
//		for (StandardEntity po : world.getEntitiesOfType(StandardEntityURN.POLICE_OFFICE)) {
//			if (po == null) continue;
//			for (StandardEntity refuge : world.getEntitiesOfType(StandardEntityURN.REFUGE)) {
//				if (refuge == null) continue;
//				List<EntityID> ids = router.getAStar((Area) po, (Area) refuge, router.getNormalCostFunction());
//				//System.out.println(ids.size());
//				for (EntityID id : ids) {
//					exMap.put(id, new EntityExtension(Color.MAGENTA, new BasicStroke(3.0f)));
//					//System.out.println(id);
//				}
//			}
//		}
		return exMap;
	}
	
	@Override
	public void customRender(Graphics2D g, ScreenTransform t, int width, int height) {
	}
	
	  //_/_/_/_/_/_/_/_/_/_/_/_/_/
	 //_/ 以下CommandCall用 /_/
	//_/_/_/_/_/_/_/_/_/_/_/_/
	
	@Override
	public String getCommandsCall() {
		if (lastCommand == null) {
			return "";
		}
		return lastCommand;
	}
	
	@Override
	protected void think(int time, ChangeSet changed, Collection<Command> heard) {
		final long thinkStart = System.currentTimeMillis();
		super.think(time, changed, heard);
		lastCommand += ": " + (System.currentTimeMillis() - thinkStart) + "[ms]";
	}
	
	@Override
	protected void act() throws ActionCommandException {
		lastCommand = "act";
		super.act();
	}

	// 以下自動生成
	
}
