package rione.communication;

import rescuecore2.worldmodel.ChangeSet;
import rescuecore2.worldmodel.EntityID;
import rione.io.BitArrayInputStream;

public interface Port {
	// コンストラクタは生成時に呼ばれます．
	
	// メッセージを生成するとき
	/**
	 * 各サイクルのvoiceやradioのMessageを生成する直前で呼ばれます．
	 * @param changed 
	 */
	// ChangeSetだけじゃなくて複数必要になたら引数専用のクラスを作ったほうがマシかも
	void init(final ChangeSet changed);
	
	/**
	 * 次のメッセージが存在するか<br>
	 * べっ，別に1つのセクションにまとめたっていいんだからねっ<br>
	 * ヘッダの節約とlimitで弾かれるリスクを考えて調整してください<br>
	 */
	boolean hasNext();
	
	/**
	 * 次のメッセージ<br>
	 * MessageBitSectionには必ずreadで読みだす分と同じビット数だけ書いてください．
	 */
	MessageBitSection next();
	
	// メッセージを読むとき
	/**
	 * メッセージを読み出すときに呼ばれます．<br>
	 * 必ずnextでMessageBitSectionに書きだした分と同じビット数だけ読んでください．<br>
	 * ノイズが存在するので，ありえない値等に注意．
	 * @param sender 
	 * @param stream
	 */
	void read(final EntityID sender, final int time, final BitArrayInputStream stream);
}
