package rione.communication.channel;

/**
 * チャンネル管理クラスのインタフェース
 * @author utisam
 *
 */
public interface ChannelManager {
	/** 更新処理 */
	public abstract void update();
	/** 無線通信チャネル */
	public abstract int getSendChannel();
	/** 音声通信チャネル */
	public abstract int getSpeakChannel();
	/** 受信チャネル */
	public abstract int[] getSubscribeChannels();
	/** そのチャネルが音声か */
	public abstract boolean isVoiceChannel(final int channel);
	/** そのチャネルが無線か */
	public abstract boolean isRadioChannel(final int channel);

}