package rione.model;

import java.util.EnumSet;

import rescuecore2.standard.entities.StandardEntityURN;

public class AgentConstants {
	
	/** 全てのEntity */
	public static final EnumSet<StandardEntityURN> INDEX_CLASS = EnumSet.of(
			StandardEntityURN.AMBULANCE_TEAM,
			StandardEntityURN.FIRE_BRIGADE,
			StandardEntityURN.POLICE_FORCE,
			StandardEntityURN.BUILDING,
			StandardEntityURN.AMBULANCE_CENTRE,
			StandardEntityURN.FIRE_STATION,
			StandardEntityURN.POLICE_OFFICE,
			StandardEntityURN.ROAD,
			StandardEntityURN.REFUGE,
			StandardEntityURN.BUILDING,
			StandardEntityURN.BLOCKADE,
			StandardEntityURN.CIVILIAN,
			StandardEntityURN.HYDRANT,
			StandardEntityURN.GAS_STATION);

	/** ユニフォームを持つエンティティ */
	public static final EnumSet<StandardEntityURN> UNIFORMABLE_ENTITIES = EnumSet.of(
			StandardEntityURN.AMBULANCE_TEAM,
			StandardEntityURN.FIRE_BRIGADE,
			StandardEntityURN.POLICE_FORCE,
			StandardEntityURN.BUILDING,
			StandardEntityURN.ROAD,
			StandardEntityURN.REFUGE,
			StandardEntityURN.HYDRANT,
			StandardEntityURN.GAS_STATION);
	
	/** 建物、道のEntity */
	public static final EnumSet<StandardEntityURN> AREAS = EnumSet.of(
			StandardEntityURN.ROAD,
			StandardEntityURN.BUILDING,
			StandardEntityURN.REFUGE,
			StandardEntityURN.AMBULANCE_CENTRE,
			StandardEntityURN.POLICE_OFFICE,
			StandardEntityURN.FIRE_STATION,
			StandardEntityURN.HYDRANT,
			StandardEntityURN.GAS_STATION);
	
	/** 建物のEntity */
	public static final EnumSet<StandardEntityURN> BUILDINGS = EnumSet.of(
			StandardEntityURN.BUILDING,
			StandardEntityURN.REFUGE,
			StandardEntityURN.AMBULANCE_CENTRE,
			StandardEntityURN.POLICE_OFFICE,
			StandardEntityURN.FIRE_STATION,
			StandardEntityURN.GAS_STATION);
	
	/** 3種類のEntity */
	public static final EnumSet<StandardEntityURN> PLATOONS = EnumSet.of(
			StandardEntityURN.AMBULANCE_TEAM,
			StandardEntityURN.FIRE_BRIGADE,
			StandardEntityURN.POLICE_FORCE);
	
	/** 全てのAgentのEntity */
	public static final EnumSet<StandardEntityURN> HUMANOIDS = EnumSet.of(
			StandardEntityURN.AMBULANCE_TEAM,
			StandardEntityURN.FIRE_BRIGADE,
			StandardEntityURN.POLICE_FORCE,
			StandardEntityURN.CIVILIAN);


}
