package rione.test;


import java.util.List;

import junit.framework.TestCase;

import org.junit.Before;
import org.junit.Test;

import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.worldmodel.EntityID;
import rione.model.AdvancedWorldModel;
import rione.model.AgentConstants;
import rione.model.route.pov.POVRouter;
import rione.model.route.pov.graph.PointOfVisivility;

public class POVRouterTest extends TestCase {

	private POVRouter router = null;
	private AdvancedWorldModel world;
	
	@Override
	@Before
	public void setUp() throws Exception {
		world = MockWorldModel.getMockWorldModel();
		router = new POVRouter(null, world);
	}

	@Test
	public void testGetDicAreaNode() {
		PointOfVisivility dicAreaNode = new PointOfVisivility(world);
		for (StandardEntity se : world.getEntitiesOfType(AgentConstants.AREAS)) {
			assertNotNull("全てのAreaに対してAreaNodeが存在する．", dicAreaNode.get(se.getID()));
		}
	}
	@Test
	public void testGetDest() {
		for (StandardEntity po : world.getEntitiesOfType(StandardEntityURN.POLICE_OFFICE)) {
			List<EntityID> idsDijkstra = router.getMultiDest((Area) po, world.getEntitiesOfType(StandardEntityURN.REFUGE), router.getPfCostFunction());
			System.out.println(idsDijkstra);
			assertTrue("PoliceOfficeとRefuge間のパスのサイズは必ず2以上です(ダイクストラ)", idsDijkstra.size() >= 2);
			System.out.println(po);
			for (StandardEntity refuge : world.getEntitiesOfType(StandardEntityURN.REFUGE)) {
				System.out.println(refuge);
				List<EntityID> ids = router.getAStar((Area) po, (Area) refuge, router.getPfCostFunction());
				System.out.println(ids);
				assertTrue("PoliceOfficeとRefuge間のパスのサイズは必ず2以上です(A*)", ids.size() >= 2);
			}
			//ならない場合がある
			//assertEquals("A*のルートはダイクストラ法で求めたルートの１つです", count, 1);
		}
	}
	
	@Test
	public void testReachableWithinTime() {
		//TODO
	}
}
