package rione.util;

import java.util.Comparator;

import rescuecore2.standard.entities.StandardEntity;

/**
 * EntityIDでソートするためのコンパレータ
 * @author com
 *
 */
public class IdSorter implements Comparator<StandardEntity> {
	
	/** 昇順か降順か */
	private final OrderBy order;

	/**
	 * 標準コンストラクタ
	 * @param order 昇順か降順か
	 */
	public IdSorter(OrderBy order) {
		this.order = order;
	}
	
	/**
	 * 省略コンストラクタ
	 * 自動的に昇順にソートされる
	 */
	public IdSorter() {
		this.order = OrderBy.ASC;
	}

	@Override
	public int compare(StandardEntity a, StandardEntity b) {
		return (a.getID().getValue() - b.getID().getValue()) * order.by();
	}
}
